/*
 *  Cryptographic "Data-as-Key" Feedback Analyser
 *
 *  Copyright (C) 2005, 2008 Luke Kenneth Casson Leighton
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*#define TEST_HISTOGRAM*/

#include <stdio.h>
#include <math.h>
#include "bitcount.h"

void save_data(int count, unsigned char *d, int len)
{
	int i;
    char fname[128];
    FILE *fp;

    sprintf(fname, "output.%d.txt", count);
    fp = fopen(fname, "w");
    
	for (i = 0; i < len; i++)
	{
        float x = round(256 * ((float)i) / ((float)len));
        unsigned char _x = (int)x;
        int nb = num_bits(&d[i], 1);
        int ab = num_bits(&_x, 1);
		fprintf(fp, "%d %d %d %d %d %d\n", i, d[i], (int)x, d[i]-(int)x,
                   nb, nb-ab);
	}
	fprintf(fp, "\n");
    fclose(fp);
}

void write_data(unsigned char *d, int len)
{
	int i;
	for (i = 0; i < len; i++)
	{
		printf("%c", d[i]);
	}
	printf("\n");
	fflush(stdout);
}

void print_data(unsigned char *d, int len)
{
	int i;
	for (i = 0; i < len; i++)
	{
		printf("%02x ", d[i]);
	}
	printf("\n");
	fflush(stdout);
}

